Public Member Functions | Protected Attributes | Private Member Functions | Private Attributes

# NWidgetMatrix Class Reference
[Hierarchical widgets]

Matrix container with implicitly equal sized (virtual) sub-widgets. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetMatrix:

## Public Member Functions
void | SetIndex (int index)
void | SetColour (Colours colour)
void | SetClicked (int clicked)
| Sets the clicked widget in the matrix.
void | SetCount (int count)
| Set the number of elements in this matrix.
void | SetScrollbar (Scrollbar *sb)
| Assign a scrollbar to this matrix.
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
void | FillNestedArray (NWidgetBase **array, uint length)
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
void | Draw (const Window *w)
| Draw the widgets of the tree.
## Protected Attributes
int | index
| If non-negative, index in the Window::nested_array.
Colours | colour
| Colour of this widget.
int | clicked
| The currently clicked widget.
int | count
| Amount of valid widgets.
Scrollbar * | sb
| The scrollbar we're associated with.
## Private Member Functions
void | GetScrollOffsets (int &start_x, int &start_y, int &base_offs_x, int &base_offs_y)
| Get the different offsets that are influenced by scrolling.
## Private Attributes
int | widget_w
| The width of the child widget including inter spacing.
int | widget_h
| The height of the child widget including inter spacing.
int | widgets_x
| The number of visible widgets in horizontal direction.
int | widgets_y
| The number of visible widgets in vertical direction.

## Detailed Description

Matrix container with implicitly equal sized (virtual) sub-widgets.

This widget must have exactly one sub-widget. After that this sub-widget is used to draw all of the data within the matrix piece by piece. DrawWidget and OnClick calls will be done to that sub-widget, where the 16 high bits are used to encode the index into the matrix.

Definition at line 491 of file widget_type.h.

## Member Function Documentation

void NWidgetMatrix::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl |
| ) |  |  | `[virtual]`

Assign size and position to the widget.

Parameters:

  | sizing | Type of resizing to perform.
  | x | Horizontal offset of the widget relative to the left edge of the window.
  | y | Vertical offset of the widget relative to the top edge of the window.
  | given_width | Width allocated to the widget.
  | given_height | Height allocated to the widget.
  | rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1517 of file widget.cpp.

References CeilDiv(), count, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetContainer::head, NWidgetPIPContainer::pip_inter, NWidgetPIPContainer::pip_post, NWidgetPIPContainer::pip_pre, NWidgetBase::pos_x, NWidgetBase::pos_y, SetCount(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, widget_h, widget_w, widgets_x, and widgets_y.

void NWidgetMatrix::Draw | ( | const Window * | w | ) | `[virtual]`

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters:

  | w | Window that owns the tree.

Reimplemented from NWidgetPIPContainer.

Definition at line 1577 of file widget.cpp.

References _colour_gradient, _current_text_dir, NWidgetResizeBase::AssignSizePosition(), clicked, colour, count, NWidgetBase::current_x, NWidgetBase::current_y, NWidgetBase::Draw(), FillDrawPixelInfo(), GetScrollOffsets(), GfxFillRect(), NWidgetContainer::head, NWidgetCore::index, NWidgetPIPContainer::pip_post, NWidgetPIPContainer::pip_pre, NWidgetBase::pos_x, NWidgetBase::pos_y, SB(), NWidgetCore::SetLowered(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, ST_RESIZE, widget_h, widget_w, widgets_x, and widgets_y.

void NWidgetMatrix::GetScrollOffsets | ( | int & | start_x,
|  | int & | start_y,
|  | int & | base_offs_x,
|  | int & | base_offs_y |
| ) |  |  | `[private]`

Get the different offsets that are influenced by scrolling.

Parameters:

  `[out]` | start_x | The start position in columns,
  `[out]` | start_y | The start position in rows.
  `[out]` | base_offs_x | The base horizontal offset in pixels.
  `[out]` | base_offs_y | The base vertical offset in pixels.

Definition at line 1631 of file widget.cpp.

References _current_text_dir, Scrollbar::GetCapacity(), Scrollbar::GetPosition(), Scrollbar::IsVertical(), NWidgetPIPContainer::pip_inter, NWidgetPIPContainer::pip_post, NWidgetPIPContainer::pip_pre, sb, TD_RTL, widget_h, widget_w, and widgets_x.

Referenced by Draw(), and GetWidgetFromPos().

NWidgetCore * NWidgetMatrix::GetWidgetFromPos | ( | int | x,
|  | int | y |
| ) |  |  | `[virtual]`

Retrieve a widget by its position.

Parameters:

  | x | Horizontal position relative to the left edge of the window.
  | y | Vertical position relative to the top edge of the window.

Returns:
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Reimplemented from NWidgetPIPContainer.

Definition at line 1547 of file widget.cpp.

References _current_text_dir, NWidgetResizeBase::AssignSizePosition(), count, NWidgetBase::current_x, NWidgetBase::current_y, GetScrollOffsets(), NWidgetCore::GetWidgetFromPos(), NWidgetContainer::head, NWidgetCore::index, IsInsideBS(), NWidgetPIPContainer::pip_pre, NWidgetBase::pos_x, NWidgetBase::pos_y, SB(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, ST_RESIZE, widget_h, widget_w, and widgets_x.

void NWidgetMatrix::SetClicked | ( | int | clicked | ) |

Sets the clicked widget in the matrix.

Parameters:

  | clicked | The clicked widget.

Definition at line 1443 of file widget.cpp.

References Scrollbar::GetPosition(), NWidgetPIPContainer::pip_inter, sb, Scrollbar::ScrollTowards(), widget_h, and widgets_x.

void NWidgetMatrix::SetCount | ( | int | count | ) |

Set the number of elements in this matrix.

Note:
  Updates the number of elements/capacity of the real scrollbar.

Parameters:

  | count | The number of elements.

Definition at line 1460 of file widget.cpp.

References CeilDiv(), NWidgetBase::current_x, NWidgetBase::current_y, NWidgetContainer::head, Scrollbar::IsVertical(), NWidgetPIPContainer::pip_inter, NWidgetPIPContainer::pip_post, NWidgetPIPContainer::pip_pre, sb, Scrollbar::SetCapacity(), Scrollbar::SetCount(), Scrollbar::SetStepSize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, widget_h, widget_w, widgets_x, and widgets_y.

Referenced by AssignSizePosition(), and BuildRailStationWindow::OnClick().

void NWidgetMatrix::SetScrollbar | ( | Scrollbar * | sb | ) |

Assign a scrollbar to this matrix.

Parameters:

  | sb | The scrollbar to assign to us.

Definition at line 1483 of file widget.cpp.

void NWidgetMatrix::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array |
| ) |  |  | `[virtual]`

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters:

  | w | Window owning the widget.
  | init_array | Initialize the `w->nested_array`.

Note:
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1488 of file widget.cpp.

References NWidgetBase::fill_x, NWidgetBase::fill_y, NWidgetContainer::head, index, Window::nested_array, Window::nested_array_size, NWidgetBase::next, NWidgetPIPContainer::pip_inter, NWidgetPIPContainer::pip_post, NWidgetPIPContainer::pip_pre, NWidgetBase::resize_x, NWidgetBase::resize_y, SB(), NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, and Window::UpdateWidgetSize().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp